Loading...
Searching...
No Matches
casacore::LELLattice< T > Class Template Reference
lattices package (libcasa_lattices) » LEL_module » LEL_module_internal_classes

More...

`#include <LELLattice.h>`

## Public Member Functions

| LELLattice (const Lattice< T > &lattice)
| Constructor takes lattice to fetch from it.
| LELLattice (const MaskedLattice< T > &lattice)
| ~LELLattice ()
| Destructor does nothing.
virtual void | eval (LELArray< T > &result, const Slicer &section) const
| Evaluate the expression; this means get the chunk of the lattice.
virtual void | evalRef (LELArrayRef< T > &result, const Slicer &section) const
virtual LELScalar< T > | getScalar () const
| Getting a scalar value is not possible (throws exception).
virtual Bool | prepareScalarExpr ()
| Do further preparations (e.g.
virtual String | className () const
| Get class name.
virtual Bool | lock (FileLocker::LockType, uInt nattempts)
| Handle locking/syncing of a lattice in a lattice expression.
virtual void | unlock ()
virtual Bool | hasLock (FileLocker::LockType) const
virtual void | resync ()
Public Member Functions inherited from casacore::LELInterface< T >
virtual | ~LELInterface ()
| Virtual destructor.
LELArray< T > | getArray () const
| Get the result of an array subexpression.
Bool | isScalar () const
| Is the result of evaluating this expression a scalar ?
const IPosition & | shape () const
| Get the shape of the expression result.
const LELAttribute & | getAttribute () const
| Get expression attribute.

## Private Attributes

MaskedLattice< T > * | pLattice_p

## Additional Inherited Members

Static Public Member Functions inherited from casacore::LELInterface< T >
static Bool | replaceScalarExpr (std::shared_ptr< LELInterface< T > > &expr)
| If the given expression is a valid scalar, replace it by its result.
Protected Member Functions inherited from casacore::LELInterface< T >
void | setAttr (const LELAttribute &attrib)
| Set the expression attributes of this object.

## Detailed Description

template<class T>
class casacore::LELLattice< T >

This LEL class handles access to Lattices

### Intended use:

Internal

### Review Status

Date Reviewed:
  yyyy/mm/dd

### Prerequisite

- Lattice
- LatticeExpr
- LatticeExprNode
- LELInterface

### Etymology

This derived LEL letter class handles access to the pixels in a Lattice

### Synopsis

This LEL letter class is derived from LELInterface. It is used to construct LEL objects that access the pixels in a Lattice. It works with Lattices of type Float,Double,Complex,DComplex and Bool.

A description of the implementation details of the LEL classes can be found in Note 216

### Example

Examples are not very useful as the user would never use these classes directly. Look in LatticeExprNode.cc to see how it invokes these classes. An example of how the user would indirectly use this class (through the envelope) is:

IPosition shape(2,5,10);
ArrayLattice<Float> x(shape); x.set(1.0);
ArrayLattice<Float> y(shape);
y.copyData(x); // y = x
casacore::ArrayLattice
Definition ArrayLattice.h:144
casacore::IPosition
Definition IPosition.h:117
casacore::LELInterface::shape
const IPosition & shape() const
Get the shape of the expression result.
Definition LELInterface.h:180

### Motivation

Accessing Lattices is fundamental to manipulating their pixel values

Definition at line 93 of file LELLattice.h.

## Constructor & Destructor Documentation

## LELLattice() [1/2]

template<class T>

casacore::LELLattice< T >::LELLattice | ( | const Lattice< T > & | lattice | ) |

Constructor takes lattice to fetch from it.

## LELLattice() [2/2]

template<class T>

casacore::LELLattice< T >::LELLattice | ( | const MaskedLattice< T > & | lattice | ) |

## ~LELLattice()

template<class T>

casacore::LELLattice< T >::~LELLattice | ( |  | ) |

Destructor does nothing.

## Member Function Documentation

## className()

template<class T>

virtual String casacore::LELLattice< T >::className | ( |  | ) | const

virtual

Get class name.

Implements casacore::LELInterface< T >.

## eval()

template<class T>

virtual void casacore::LELLattice< T >::eval | ( | LELArray< T > & | result,
|  | const Slicer & | section ) const

virtual

Evaluate the expression; this means get the chunk of the lattice.

Implements casacore::LELInterface< T >.

## evalRef()

template<class T>

virtual void casacore::LELLattice< T >::evalRef | ( | LELArrayRef< T > & | result,
|  | const Slicer & | section ) const

virtual

Reimplemented from casacore::LELInterface< T >.

## getScalar()

template<class T>

virtual LELScalar< T > casacore::LELLattice< T >::getScalar | ( |  | ) | const

virtual

Getting a scalar value is not possible (throws exception).

Implements casacore::LELInterface< T >.

## hasLock()

template<class T>

virtual Bool casacore::LELLattice< T >::hasLock | ( | FileLocker::LockType |  | ) | const

virtual

Reimplemented from casacore::LELInterface< T >.

## lock()

template<class T>

virtual Bool casacore::LELLattice< T >::lock | ( | FileLocker::LockType | ,
|  | uInt | nattempts )

virtual

Handle locking/syncing of a lattice in a lattice expression.

Reimplemented from casacore::LELInterface< T >.

## prepareScalarExpr()

template<class T>

virtual Bool casacore::LELLattice< T >::prepareScalarExpr | ( |  | ) |

virtual

Do further preparations (e.g.

optimization) on the expression.

Implements casacore::LELInterface< T >.

## resync()

template<class T>

virtual void casacore::LELLattice< T >::resync | ( |  | ) |

virtual

Reimplemented from casacore::LELInterface< T >.

## unlock()

template<class T>

virtual void casacore::LELLattice< T >::unlock | ( |  | ) |

virtual

Reimplemented from casacore::LELInterface< T >.

## Member Data Documentation

## pLattice_p

template<class T>

MaskedLattice<T>* casacore::LELLattice< T >::pLattice_p

private

Definition at line 135 of file LELLattice.h.

The documentation for this class was generated from the following file:

- lattices/LEL/LELLattice.h